package sockets;

import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import static sockets.Server.getData;
import static sockets.Server.writeData;

public class Server {
    
    private static String[] srv = new String[20]; 
    
    public static void writeData(String data, String path, boolean concatena) {
        try {
            BufferedReader br = null;
            StringBuffer sb = new StringBuffer();
            if (concatena) {
                InputStream is = new FileInputStream(path);
                InputStreamReader isr = new InputStreamReader(is);
                br = new BufferedReader(isr);
            }
            if (br != null) {
                String s = br.readLine();// primeira linha
                while (s != null) {
                    sb.append(s + "\n");
                    s = br.readLine();
                }
                br.close();
                sb.append("" + data);
            } else {
                sb.append("" + data);
            }

            OutputStream os = new FileOutputStream(path);
            OutputStreamWriter osw = new OutputStreamWriter(os);
            BufferedWriter bw = new BufferedWriter(osw);
            bw.write(sb.toString());
            bw.close();
        } catch (IOException ex) {
            System.err.println("erro: " + ex.toString());
        }
    }

    public static BufferedReader getData(String file) {

        try {
            InputStream is = new FileInputStream(file);
            InputStreamReader isr = new InputStreamReader(is);
            BufferedReader br = new BufferedReader(isr);
            //br.close();//devemos devolver aberto o stream...         
            return br;
        } catch (java.io.FileNotFoundException FNE) {
            System.out.println("Arquivos não encontrado!");
        }
        return null;
    }

    public static void main(String[] args) {
        
        srv[0]="192.168.2.101";
        srv[1]="192.168.2.101";
        srv[2]="192.168.2.102";
        srv[3]="192.168.2.103";
        srv[4]="192.168.2.104";
        

        try {
            ServerSocket serverSocket = new ServerSocket(8000);
            System.out.println("Porta 8000 aberta. "
                    + "verifique com $netstat -na | grep :8000");

            System.out.println("Esperando pelo cliente:");
            Socket clientSocket = serverSocket.accept();
            System.out.println("Conectado com o cliente: "
                    + clientSocket.getInetAddress().getHostAddress());
            PrintWriter out = new PrintWriter(clientSocket.getOutputStream(), true);
            BufferedReader in = new BufferedReader(
                    new InputStreamReader(clientSocket.getInputStream()));

            String inputLine;
            out.println("Opcoes: help, saveData, showData, quit|sair");

            while ((inputLine = in.readLine()) != null) {
                if (inputLine.equalsIgnoreCase("help")){
                    System.out.println("showData -> mostra conteúdo do arquivo socketData.txt");
                    System.out.println("saveData -> salva socketData.txt em todos servidores");
                }
                if (inputLine.equalsIgnoreCase("quit")
                        || inputLine.equalsIgnoreCase("Sair")) {
                    break;
                }

                if (inputLine.equalsIgnoreCase("showData")) {
                    System.out.println("Cliente: showData");
                    BufferedReader br = getData("socketData.txt");
                    String s = br.readLine(); // primeira linha
                    while (s != null) {
                        out.println(s);
                        s = br.readLine();
                    }
                    br.close();
                }

                if (inputLine.equalsIgnoreCase("saveData")) {
                    System.out.println("Cliente: saveData");
                    for (int i=0;i<srv.length;i++ ){
                        if(srv[i] != null){
                            System.out.println("Enviando para: "+srv[i]);
                            Socket cliSocket = new Socket(srv[i], 8000);
                            PrintWriter out2 = new PrintWriter(cliSocket.getOutputStream(), true);
                            out2.println("SALVANDO ALGO !!!!!");                            
                            out2.close();
                            cliSocket.close();
                        }
                    }
                    
                } 
                
                else if (!inputLine.equalsIgnoreCase("showData")
                        && !inputLine.equalsIgnoreCase("saveData")
                        && !inputLine.equalsIgnoreCase("help")) {
                    writeData(inputLine, "socketData.txt", true);
                    out.println("... Texto salvo em disco!");
                }
            }
            in.close();
            serverSocket.close();
            clientSocket.close();
        } catch (java.net.BindException be) {
            System.out.println("Porta já está em uso.");
        } catch (IOException ex) {
            ex.printStackTrace();
        }

    }
}
